#include <OutlookEX.au3>

; *****************************************************************************
; Create test environment
; *****************************************************************************
Global $oOutlook = _OL_Open()
If @error <> 0 Then Exit MsgBox($MB_ICONERROR, "OutlookEX UDF", "Error creating a connection to Outlook. @error = " & @error & ", @extended = " & @extended)

Global $Result = _OL_TestEnvironmentCreate($oOutlook)
If @error <> 0 Then Exit MsgBox($MB_ICONERROR, "OutlookEX UDF - Manage Test Environment", "Error creating the test environment. @error = " & @error & ", @extended = " & @extended)

; *****************************************************************************
; Example 1
; Find a mail item in the specified folder and create $iNumberOfMails copies in the same folder
; Measure the time needed when using _OL_ItemCopy and _OL_ItemBulk
; *****************************************************************************
Global $iNumberOfMails = 100 ; Number of Testmails to create
Global $aFolder = _OL_FolderAccess($oOutlook, "*\Outlook-UDF-Test\SourceFolder\Mail")
Global $aOL_Items = _OL_ItemFind($oOutlook, $aFolder[1], $olMail, "", "", "", "@ItemObject")
If $aOL_Items[0][0] = 0 Then Exit MsgBox($MB_ICONERROR, "OutlookEX UDF: _OL_ItemBulk Example Script", "Could not find a mail item in folder '*\Outlook-UDF-Test\SourceFolder\Mail'. @error = " & @error)
ReDim $aOL_Items[$iNumberOfMails+2][1]
$aOL_Items[0][0] = $iNumberOfMails+1

; Create the copies
Global $iTime = TimerInit()
For $i = 1 To $iNumberOfMails
	$aOL_Items[$i+1][0] = _OL_ItemCopy($oOutlook, $aOL_Items[1][0])
Next
MsgBox($MB_ICONINFORMATION, "OutlookEX UDF: _OL_ItemBulk Example Script", "Test-Mails successfully created using _OL_ItemCopy!" & @CRLF & "Time to process: " & TimerDiff($iTime) & " milliseconds.")

; Create the target folder to copy/move the mails to (as a sub-folder of $aFolder)
Global $oTargetFolder = _OL_FolderCreate($oOutlook, "Target", $olFolderInbox, "*\Outlook-UDF-Test\SourceFolder\Mail")
If @error Then MsgBox($MB_ICONERROR, "OutlookEX UDF: _OL_ItemBulk Example Script", "Error creating Folder '*\Outlook-UDF-Test\SourceFolder\Mail\Target'. @error = " & @error)

; Copy
Global $iFlag = 1
$iTime = TimerInit()
Global $aErrors = _OL_ItemBulk($oOutlook, $aOL_Items, Default, $oTargetFolder, 1, Default, Default, $iFlag)
If @error <> 0 Then
	MsgBox($MB_ICONERROR, "OutlookEX UDF: _OL_ItemBulk Example Script", "Error copying specified items. @error = " & @error & ", @extended = " & @extended)
	If $iFlag = 1 Then _ArrayDisplay($aErrors)
Else
	MsgBox($MB_ICONINFORMATION, "OutlookEX UDF: _OL_ItemBulk Example Script", "Mails successfully copied using _OL_ItemBulk!" & @CRLF & "Time to process: " & TimerDiff($iTime) & " milliseconds.")
EndIf

; Move
Global $iFlag = 1
$iTime = TimerInit()
Global $aErrors = _OL_ItemBulk($oOutlook, $aOL_Items, Default, $oTargetFolder, 3, Default, Default, $iFlag)
If @error <> 0 Then
	MsgBox($MB_ICONERROR, "OutlookEX UDF: _OL_ItemBulk Example Script", "Error moving specified items. @error = " & @error & ", @extended = " & @extended)
	If $iFlag = 1 Then _ArrayDisplay($aErrors)
Else
	MsgBox($MB_ICONINFORMATION, "OutlookEX UDF: _OL_ItemBulk Example Script", "Mails successfully moved using _OL_ItemBulk!" & @CRLF & "Time to process: " & TimerDiff($iTime) & " milliseconds.")
EndIf

_OL_Close($oOutlook)
